org.apache.commons.math.ode.jacobians

## Interface EventHandlerWithJacobians

- Deprecated.
  as of 2.2 the complete package is deprecated, it will be replaced in 3.0 by a completely rewritten implementation

      @Deprecated
      public interface EventHandlerWithJacobians

  This interface represents a handler for discrete events triggered during ODE integration.

  Some events can be triggered at discrete times as an ODE problem is solved. This occurs for example when the integration process should be stopped as some state is reached (G-stop facility) when the precise date is unknown a priori, or when the derivatives have discontinuities, or simply when the user wants to monitor some states boundaries crossings.

  These events are defined as occurring when a `g` switching function sign changes.

  Since events are only problem-dependent and are triggered by the independent time variable and the state vector, they can occur at virtually any time, unknown in advance. The integrators will take care to avoid sign changes inside the steps, they will reduce the step size when such an event is detected in order to put this event exactly at the end of the current step. This guarantees that step interpolation (which always has a one step scope) is relevant even in presence of discontinuities. This is independent from the stepsize control provided by integrators that monitor the local error (this event handling feature is available for all integrators, including fixed step ones).

  Note that is is possible to register a `classical event handler` in the low level integrator used to build a `FirstOrderIntegratorWithJacobians` rather than implementing this class. The event handlers registered at low level will see the big compound state whether the event handlers defined by this interface see the original state, and its jacobians in separate arrays.

  The compound state is guaranteed to contain the original state in the first elements, followed by the jacobian with respect to initial state (in row order), followed by the jacobian with respect to parameters (in row order). If for example the original state dimension is 6 and there are 3 parameters, the compound state will be a 60 elements array. The first 6 elements will be the original state, the next 36 elements will be the jacobian with respect to initial state, and the remaining 18 elements will be the jacobian with respect to parameters.

  Dealing with low level event handlers is cumbersome if one really needs the jacobians in these methods, but it also prevents many data being copied back and forth between state and jacobians on one side and compound state on the other side. So for performance reasons, it is recommended to use this interface only if jacobians are really needed and to use lower level handlers if only state is needed.

  Since:
    2.1
  Version:
    $Revision: 1037341 $ $Date: 2010-11-20 22:58:35 +0100 (sam. 20 nov. 2010) $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `CONTINUE` Deprecated. Continue indicator.
    `static int` | `RESET_DERIVATIVES` Deprecated. Reset derivatives indicator.
    `static int` | `RESET_STATE` Deprecated. Reset state indicator.
    `static int` | `STOP` Deprecated. Stop indicator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `eventOccurred(double t, double[] y, double[][] dydy0, double[][] dydp, boolean increasing)` Deprecated. Handle an event and choose what to do next.
    `double` | `g(double t, double[] y, double[][] dydy0, double[][] dydp)` Deprecated. Compute the value of the switching function.
    `void` | `resetState(double t, double[] y, double[][] dydy0, double[][] dydp)` Deprecated. Reset the state prior to continue the integration.

- - ### Field Detail

    - #### STOP

          static final int STOP

      Deprecated.
      Stop indicator.

      This value should be used as the return value of the `eventOccurred` method when the integration should be stopped after the event ending the current step.

      See Also:
        Constant Field Values

    - #### RESET_STATE

          static final int RESET_STATE

      Deprecated.
      Reset state indicator.

      This value should be used as the return value of the `eventOccurred` method when the integration should go on after the event ending the current step, with a new state vector (which will be retrieved thanks to the `resetState` method).

      See Also:
        Constant Field Values

    - #### RESET_DERIVATIVES

          static final int RESET_DERIVATIVES

      Deprecated.
      Reset derivatives indicator.

      This value should be used as the return value of the `eventOccurred` method when the integration should go on after the event ending the current step, with a new derivatives vector (which will be retrieved thanks to the `FirstOrderDifferentialEquations.computeDerivatives(double, double[], double[])` method).

      See Also:
        Constant Field Values

    - #### CONTINUE

          static final int CONTINUE

      Deprecated.
      Continue indicator.

      This value should be used as the return value of the `eventOccurred` method when the integration should go on after the event ending the current step.

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### g

          double g(double t,
                 double[] y,
                 double[][] dydy0,
                 double[][] dydp)
                   throws EventException

      Deprecated.
      Compute the value of the switching function.

      The discrete events are generated when the sign of this switching function changes. The integrator will take care to change the stepsize in such a way these events occur exactly at step boundaries. The switching function must be continuous in its roots neighborhood (but not necessarily smooth), as the integrator will need to find its roots to locate precisely the events.

      Parameters:
        `t` - current value of the independent time variable
        `y` - array containing the current value of the state vector
        `dydy0` - array containing the current value of the jacobian of the state vector with respect to initial state
        `dydp` - array containing the current value of the jacobian of the state vector with respect to parameters
      Returns:
        value of the g switching function
      Throws:
        `EventException` - if the switching function cannot be evaluated

    - #### eventOccurred

          int eventOccurred(double t,
                          double[] y,
                          double[][] dydy0,
                          double[][] dydp,
                          boolean increasing)
                            throws EventException

      Deprecated.
      Handle an event and choose what to do next.

      This method is called when the integrator has accepted a step ending exactly on a sign change of the function, just before the step handler itself is called (see below for scheduling). It allows the user to update his internal data to acknowledge the fact the event has been handled (for example setting a flag in the `differential equations` to switch the derivatives computation in case of discontinuity), or to direct the integrator to either stop or continue integration, possibly with a reset state or derivatives.

      - if `STOP` is returned, the step handler will be called with the `isLast` flag of the `handleStep` method set to true and the integration will be stopped,
      - if `RESET_STATE` is returned, the `resetState` method will be called once the step handler has finished its task, and the integrator will also recompute the derivatives,
      - if `RESET_DERIVATIVES` is returned, the integrator will recompute the derivatives,
      - if `CONTINUE` is returned, no specific action will be taken (apart from having called this method) and integration will continue.

      The scheduling between this method and the `StepHandlerWithJacobians` method `handleStep(interpolator, isLast)` is to call this method first and `handleStep` afterwards. This scheduling allows the integrator to pass `true` as the `isLast` parameter to the step handler to make it aware the step will be the last one if this method returns `STOP`. As the interpolator may be used to navigate back throughout the last step (as `StepNormalizer` does for example), user code called by this method and user code called by step handlers may experience apparently out of order values of the independent time variable. As an example, if the same user object implements both this `EventHandler` interface and the `FixedStepHandler` interface, a forward integration may call its `eventOccurred` method with t = 10 first and call its `handleStep` method with t = 9 afterwards. Such out of order calls are limited to the size of the integration step for `variable step handlers` and to the size of the fixed step for `fixed step handlers`.

      Parameters:
        `t` - current value of the independent time variable
        `y` - array containing the current value of the state vector
        `dydy0` - array containing the current value of the jacobian of the state vector with respect to initial state
        `dydp` - array containing the current value of the jacobian of the state vector with respect to parameters
        `increasing` - if true, the value of the switching function increases when times increases around event (note that increase is measured with respect to physical time, not with respect to integration which may go backward in time)
      Returns:
        indication of what the integrator should do next, this value must be one of `STOP`, `RESET_STATE`, `RESET_DERIVATIVES` or `CONTINUE`
      Throws:
        `EventException` - if the event occurrence triggers an error

    - #### resetState

          void resetState(double t,
                        double[] y,
                        double[][] dydy0,
                        double[][] dydp)
                          throws EventException

      Deprecated.
      Reset the state prior to continue the integration.

      This method is called after the step handler has returned and before the next step is started, but only when `eventOccurred(double, double[], double[][], double[][], boolean)` has itself returned the `RESET_STATE` indicator. It allows the user to reset the state vector for the next step, without perturbing the step handler of the finishing step. If the `eventOccurred(double, double[], double[][], double[][], boolean)` never returns the `RESET_STATE` indicator, this function will never be called, and it is safe to leave its body empty.

      Parameters:
        `t` - current value of the independent time variable
        `y` - array containing the current value of the state vector the new state should be put in the same array
        `dydy0` - array containing the current value of the jacobian of the state vector with respect to initial state, the new jacobian should be put in the same array
        `dydp` - array containing the current value of the jacobian of the state vector with respect to parameters, the new jacobian should be put in the same array
      Throws:
        `EventException` - if the state cannot be reseted

Copyright (c) 2003-2013 Apache Software Foundation